;   16 
;   
;






.include 	"tn2313adef.inc"	;  tiny2313a


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;    SREG
.def	Temp5=R21
.def	Temp6=R22			; 
.def	Temp7=R23			; 
.def	Temp8=R24
.def	Temp9=R25










;******************************************************************************
; 
;******************************************************************************



.dseg					; 



ch_count: .byte 1			;   // 0,1,2 
					;  = 3,   
					;  = 4,       





;******************************************************************************
; 
;******************************************************************************




.EQU	Chastota_const=0x9C40 		;     (  50  )
					; 50=0,02
					; 1   = 0,0000005 
					; 0,02/0,0000005=40000 ( 0x9C40 )






;******************************************************************************
;   
;******************************************************************************

.cseg

			

.org 0

rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset






.org ICP1addr				; = 0x0003 Timer/Counter1 Capture Event (    )

rjmp ICP1_interruption




.org INT_VECTORS_SIZE








;******************************************************************************
;  ***********************************************************************
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;



	
	ldi Temp,0b11111111		;   "" (0-, 1-)
	out DDRB,Temp			; 
					 
		
	ldi Temp,0b00000000		;  _0
	out PortB,Temp			; 



		
												 
	ldi Temp,0b00111111		;   "D" (0-, 1-)
	out DDRD,Temp 			; 00xxxxxx -    
					; 0000000 -    (ICP)



	ldi Temp,0b00000000		;  _0
	out PortD,Temp			;



;	RCALL	LCD_INIT		;  




;******************************************************************************
;   _1
;******************************************************************************



;    (  )
; ICP    .


					

	ldi Temp,(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11)|(1<<WGM10)
	out TCCR1A,Temp	
				
					;      OCR1A //   ,   
					; *1 (     )
					;   OC1A    !    !


					; COM1A1  /   OC1A // 
					; COM1A0  /   OC1A // 
					; COM1B1  /   OC1B // 
					; COM1B0  /   OC1B //  
					; WGM11=1 /  *
					; WGM10=0 /  *





	ldi Temp,(0<<ICES1)|(1<<WGM13)|(1<<WGM12)|(1<<cs11)	
	out TCCR1B,Temp					
					;    ICP   							;*****
					;    1/8 ( 1   = 0,5  )
					; *1



					;   = CK 1:8 (16/8=2) 1   = 0,5 
					;   !!!

					; ICNC1=0 /     ICP // 
					; ICES1=0 /    ICP   
					; WGM13=1 /  *
					; WGM12=1 /  *   ( Fast PWM )
					; CS12=0  /  
					; CS11=1  /   
					; CS10=0  /   = CK 1:8 (16/8=2) 1   = 0,5 




	LDI Temp,high(Chastota_const)	;    (    )
	OUT OCR1AH,Temp			;      
	LDI Temp,low(Chastota_const)							
	OUT OCR1AL,Temp	





	ldi Temp,(1<<ICIE1)		;     
	out TIMSK,Temp

					; TOIE1=0  /     _1 // 
					; OCIE1A=0 /  _A _1 //  
					; OCIE1B=0 /  _B _1 // 
					; ICIE1=1  /    // 
					; OCIE0B=0 /  _B _0 // 
					; TOIE=0   /     _0 // 
					; OCIE0A=0 /  _A _0 // 







;******************************************************************************
;  
;******************************************************************************



	ldi Temp,0			;  _1
	out TCNT1H,Temp
	out TCNT1L,Temp

	sei				;   




	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;   *********************************************************
;*******************************************************************************

ICP1_interruption:
	




	ldi xh, 0xB			; 3000 = 0x0BB8 -   ... ( 1,5  )
	ldi xl, 0xB8


	OUT OCR1BH,XH			;    (   )
	OUT OCR1BL,XL			;      






;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    



;**************************************************************************************************************
;  
;**************************************************************************************************************

; .include "lcd5110mini.asm"		;   	




